package com.hisschemoller.model 
{
	import com.hisschemoller.utils.Conversions;
	import com.hisschemoller.utils.parameter.MappingNumberFaderTaper;
	import com.hisschemoller.utils.parameter.Parameter;
	
	import org.puremvc.as3.interfaces.IProxy;
	import org.puremvc.as3.patterns.proxy.Proxy;	
	/**
	 * @author Wouter Hisschemoller
	 * (c) Feb 19, 2010
	 */
	public class AudioOutputProxy extends Proxy implements IProxy 
	{
		public static const NAME : String = "AudioOutputProxy";
		public static const OUTPUT_GAIN_CHANGED : String = 'outputGainChanged';
		private var _decibel : Parameter = new Parameter(new MappingNumberFaderTaper(-200, 10), -0.3);
		private var _gain : Number;
		
		public function AudioOutputProxy()
		{
			super(NAME);
		}
		
		/**
		 * 
		 */
		override public function onRegister() : void
		{
			_gain = Conversions.decibelToAmplitude(_decibel.value);
		}
		
		/**
		 * 
		 */
		public function process(buffer : Vector.<Vector.<Number>>, bufferStartIndex : uint) : void
		{
			var n : int = bufferStartIndex + AudioDriverProxy.BUFFER_BLOCK_SIZE;
			for(var i : int = bufferStartIndex;i < n; ++i)
			{
				buffer[0][i] *= _gain;
				buffer[1][i] *= _gain;
			}
		}
		
		/**
		 * @return Number: Level in decibel (-200 to 10).
		 */
		public function get decibel() : Number
		{
			return _decibel.value;
		}
		
		/**
		 * @return Number: Level normalized (0 to 1);
		 */
		public function get decibelNormalized() : Number
		{
			return _decibel.valueNormalized;
		}
		
		/**
		 * @param value: A normalized value between 0 and 1
		 */
		public function set decibelNormalized(value : Number) : void
		{
			_decibel.valueNormalized = value;
			_gain = Conversions.decibelToAmplitude(_decibel.value);
			
			facade.sendNotification(AudioOutputProxy.OUTPUT_GAIN_CHANGED, _decibel.value);
		}
	}
}
