package com.hisschemoller.utils.delegates 
{
	import com.hisschemoller.model.vo.AlertVO;
	
	import mx.rpc.Responder;
	
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.SecurityErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;	
	/**
	 * @author Wouter Hisschemoller
	 * (c) Feb 26, 2010
	 */
	public class XMLLoaderDelegate 
	{
		private var _responder : Responder;
		
		public function XMLLoaderDelegate(responder : Responder)
		{
			_responder = responder;
		}

		/**
		 * Load the XML with startup data for the application.
		 */
		public function loadXML(url : String) : void
		{
			var urlLoader : URLLoader = new URLLoader();
			urlLoader.addEventListener(Event.COMPLETE, xmlLoaderHandler);
			urlLoader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, xmlLoaderHandler);
			urlLoader.addEventListener(IOErrorEvent.IO_ERROR, xmlLoaderHandler);
			urlLoader.load(new URLRequest(url));
		}

		/**
		 * Data xml file loaded.
		 */
		private function xmlLoaderHandler(event : Event) : void
		{
			var urlLoader : URLLoader = URLLoader(event.target);
			urlLoader.removeEventListener(Event.COMPLETE, xmlLoaderHandler);
			urlLoader.removeEventListener(SecurityErrorEvent.SECURITY_ERROR, xmlLoaderHandler);
			urlLoader.removeEventListener(IOErrorEvent.IO_ERROR, xmlLoaderHandler);
			
			switch(event.type)
			{
				case Event.COMPLETE:
					_responder.result(XML(urlLoader.data));
					break;
				case SecurityErrorEvent.SECURITY_ERROR:
					_responder.fault(new AlertVO("Security Error", "The setup XML file could not be loaded because of a security error. System error message: " + SecurityErrorEvent(event).text));
				case IOErrorEvent.IO_ERROR:
					_responder.fault(new AlertVO("IO Error", "The setup XML file could not be loaded because of an IO error. Maybe the file was deleted on the server or the connection to the server failed. System error message: " + IOErrorEvent(event).text));
					break;
			}
		}
	}
}
