package com.hisschemoller.view.components 
{
	import assets.AlertAsset;

	import com.bit101.components.Component;
	import com.hisschemoller.view.components.enum.Colors;
	import com.hisschemoller.view.components.fonts.EmbeddedFont;
	import com.hisschemoller.view.components.fonts.HelveticaNeueRegular;
	import com.hisschemoller.view.components.text.FormattedTextField;
	import com.hisschemoller.view.components.ui.TextButton;

	import flash.display.DisplayObjectContainer;
	import flash.events.MouseEvent;
	import flash.text.AntiAliasType;
	/**
	 * @author Wouter Hisschemoller
	 * (c) Jan 23, 2010
	 */
	public class Alert extends Component 
	{
		private var _closeButton : TextButton;
		private var _header : FormattedTextField;
		private var _body : FormattedTextField;

		public function Alert(container : DisplayObjectContainer = null)
		{
			super(container);
		}

		/**
		 * 
		 */
		public function show(header : String, message : String) : void
		{
			visible = true;
			_header.text = header;
			_body.htmlText = "<font size='12'>" + message + "</font>";
		}

		/**
		 * 
		 */
		public function hide() : void
		{
			visible = false;
		}

		/**
		 * 
		 */
		override protected function init() : void
		{
			super.init();
			hide();
		}

		/**
		 * 
		 */
		override protected function addChildren() : void
		{
			super.addChildren();
			
			addChild(new AlertAsset());
			
			_closeButton = new TextButton(this, 320, 320, "close", handleCloseClick);
			
			_header = new FormattedTextField(EmbeddedFont.getTextFormat(HelveticaNeueRegular.FONT_NAME), 32, Colors.WHITE, 300, false, AntiAliasType.ADVANCED);
			_header.x = 117;
			_header.y = 154;
			addChild(_header);
			
			_body = new FormattedTextField(EmbeddedFont.getTextFormat(HelveticaNeueRegular.FONT_NAME), 12, Colors.WHITE, 300, true, AntiAliasType.ADVANCED);
			_body.x = 119;
			_body.y = 192;
			_body.mouseEnabled = true;
			_body.selectable = true;
			addChild(_body);
		}

		/**
		 * 
		 */
		private function handleCloseClick(inEvent : MouseEvent) : void
		{
			hide();
		}
	}
}
