package com.hisschemoller.view.components.ui 
{
	import com.bit101.components.PushButton;
	import com.hisschemoller.view.components.enum.Colors;

	import flash.display.DisplayObjectContainer;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	/**
	 * @author Wouter Hisschemoller
	 * (c) Mar 22, 2010
	 */
	public class BasicLocator extends PushButton 
	{
		protected var _hitArea : Sprite;
		protected var _locatorAsset : MovieClip;
		
		public function BasicLocator(parent : DisplayObjectContainer = null, xpos : Number = 0, ypos : Number = 0, defaultHandler : Function = null)
		{
			super(parent, xpos, ypos, "", defaultHandler);
		}

		/**
		 * Draws the visual ui of the component.
		 */
		override public function draw() : void
		{
			graphics.clear();
			graphics.beginFill(Colors.RUBY_RED);
			
			if(_enabled)
			{
				if(_over)
				{
					graphics.beginFill(Colors.BLOOD_RED);
				}
				else
				{
				}
				
				if(_down)
				{
					graphics.beginFill(Colors.BLOOD_RED);
				}
			}
			else /** Disabled. */
			{
				graphics.beginFill(Colors.BLOOD_RED);
			}
			
			if(_selected)
			{
				
			}
			else
			{
			}
			
			graphics.drawRect(0, 0, _width, _height);
		}

		/**
		 * Creates and adds the child display objects of this component.
		 */
		override protected function addChildren() : void
		{
			_hitArea = new Sprite();
			_hitArea.graphics.beginFill(0x00FF00);
			_hitArea.graphics.drawRect(0, 0, 20, 16);
			addChild(_hitArea);
			
			hitArea = _hitArea;
			
			addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			addEventListener(MouseEvent.ROLL_OVER, onMouseOver);
		}
	}
}
